#!/data/local/tmp/mm_twrp_recovery_install/busybox sh

BUSYBOX=/data/local/tmp/mm_twrp_recovery_install/busybox

if [ ! -f /data/local/tmp/mm_twrp_recovery_install/wp_mod.ko ]; then
	echo "Error patching kernel module. File not found."
	exit 1
fi

if [ ! -f /data/local/tmp/mm_twrp_recovery_install/busybox ]; then
	echo "Error: busybox not found"
	exit 1
fi

if [ -f /data/local/tmp/mm_twrp_recovery_install/modulecrcpatch ]; then
	for f in /system/lib/modules/*.ko; do
		/data/local/tmp/mm_twrp_recovery_install/modulecrcpatch $f /data/local/tmp/mm_twrp_recovery_install/wp_mod.ko
	done
fi

insmod /data/local/tmp/mm_twrp_recovery_install/wp_mod.ko
mount -o remount,rw /system
cp /data/local/tmp/mm_twrp_recovery_install/wp_mod.ko /system/lib/modules/wp_mod.ko
chmod 644 /system/lib/modules/wp_mod.ko

echo "#!/system/bin/sh" > /tmp/mount.sh
echo 'mod_loaded=`lsmod | grep wp_mod`' >> /tmp/mount.sh
echo 'if [ "$mod_loaded" = "" ]; then' >> /tmp/mount.sh
echo "	if [ -f /system/lib/modules/wp_mod.ko ]; then" >> /tmp/mount.sh
echo "		insmod /system/lib/modules/wp_mod.ko" >> /tmp/mount.sh
echo "	else" >> /tmp/mount.sh
echo "		insmod /data/local/tmp/wp_mod.ko" >> /tmp/mount.sh
echo "	fi" >> /tmp/mount.sh
echo "fi" >> /tmp/mount.sh
echo "/system/bin/stock/mount \"\$@\"" >> /tmp/mount.sh

if [ ! -f /system/bin/stock/mount ]
then
	echo "Stock mount does not exist. Creating dir and link"
	mkdir /system/bin/stock
	chmod 755 /system/bin/stock
	ln -s /system/bin/toolbox /system/bin/stock/mount
fi
rm /system/bin/mount
cp /tmp/mount.sh /system/bin/mount
chmod 755 /system/bin/mount

echo "Installing of mount.sh finished" 

if [ ! -f /data/local/tmp/mm_twrp_recovery_install/byeselinux.ko ]; then
	echo "Error patching kernel module. File not found."
	exit 1
fi

if [ ! -f /data/local/tmp/mm_twrp_recovery_install/busybox ]; then
	echo "Error: busybox not found"
	exit 1
fi

if [ -f /data/local/tmp/mm_twrp_recovery_install/modulecrcpatch ]; then
	for f in /system/lib/modules/*.ko; do
		/data/local/tmp/mm_twrp_recovery_install/modulecrcpatch $f /data/local/tmp/mm_twrp_recovery_install/byeselinux.ko
	done
fi

if [ ! -f /system/lib/modules/mhl_sii8620_8061_drv_orig.ko ]; then
	cp /system/lib/modules/mhl_sii8620_8061_drv.ko /system/lib/modules/mhl_sii8620_8061_drv_orig.ko
	chmod 644 /system/lib/modules/mhl_sii8620_8061_drv_orig.ko
fi

cp /data/local/tmp/mm_twrp_recovery_install/byeselinux.ko /system/lib/modules/mhl_sii8620_8061_drv.ko
chmod 644 /system/lib/modules/mhl_sii8620_8061_drv.ko

echo "Installing of installbyeselinux.sh finished" 

if [ ! -e /system/etc/mm_twrp_recovery ]; then

	${BUSYBOX} mkdir /system/etc/mm_twrp_recovery
	${BUSYBOX} chmod 0755 /system/etc/mm_twrp_recovery
	
fi

# copy busybox to system
${BUSYBOX} cp /data/local/tmp/mm_twrp_recovery_install/busybox /system/xbin/busybox
${BUSYBOX} chown 0.2000 /system/xbin/busybox
${BUSYBOX} chmod 755 /system/xbin/busybox

BUSYBOX=/system/xbin/busybox

# symlinking busybox applets
for i in $(${BUSYBOX} --list); do

	${BUSYBOX} ln -sf ${BUSYBOX} "/system/xbin/$i"
	
done

# copy busybox to system
${BUSYBOX} cp /data/local/tmp/mm_twrp_recovery_install/busybox /system/etc/mm_twrp_recovery/busybox
${BUSYBOX} chown 0.2000 /system/etc/mm_twrp_recovery/busybox
${BUSYBOX} chmod 755 /system/etc/mm_twrp_recovery/busybox

# copy twrp recovery
${BUSYBOX} cp /data/local/tmp/mm_twrp_recovery_install/recovery.twrp.cpio.lzma /system/etc/mm_twrp_recovery/recovery.twrp.cpio.lzma
${BUSYBOX} chown 0.0 /system/etc/mm_twrp_recovery/recovery.twrp.cpio.lzma
${BUSYBOX} chmod 644 /system/etc/mm_twrp_recovery/recovery.twrp.cpio.lzma

# copy reboot twrp recovery script
${BUSYBOX} cp /data/local/tmp/mm_twrp_recovery_install/boot_twrp_recovery.sh /system/etc/mm_twrp_recovery/boot_twrp_recovery.sh
${BUSYBOX} chown 0.0 /system/etc/mm_twrp_recovery/boot_twrp_recovery.sh
${BUSYBOX} chmod 755 /system/etc/mm_twrp_recovery/boot_twrp_recovery.sh

# chargemon hack
if [ ! -e "/system/bin/chargemon.stock" ]; then

	${BUSYBOX} mv /system/bin/chargemon /system/bin/chargemon.stock
	
fi
${BUSYBOX} cp /data/local/tmp/mm_twrp_recovery_install/chargemon.sh /system/bin/chargemon
${BUSYBOX} chown 0.0 /system/bin/chargemon
${BUSYBOX} chmod 755 /system/bin/chargemon
${BUSYBOX} echo "SYSTEMLESS=false" >> /data/.supersu

# first boot goes to recovery
if [ -e /cache/recovery/ ]; then
	busybox touch /cache/recovery/boot
else
	busybox mkdir /cache/recovery/
	busybox touch /cache/recovery/boot
fi
